unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, 
  Dialogs, StdCtrls, LMessages, LCLIntf;

type

  { TMyEdit }

  TMyEdit = class(TCustomEdit)
  private
    FExtCursorReadOnly: TCursor;
    FCurrentCursor: TCursor;
    function GetMyCursor: TCursor;
    procedure SetMyCursor(AValue: TCursor);
  protected
    procedure SetExtCursorReadOnly(AValue: TCursor);
    procedure SetReadOnly(Value: Boolean); override;
  published
    property ExtCursorReadOnly: TCursor read FExtCursorReadOnly write SetExtCursorReadOnly default crDefault;
    property Cursor: TCursor read GetMyCursor write SetMyCursor default crDefault;
  end;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    MyEdit: TMyEdit;
    TestEdit: TMyEdit;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  MyEdit := TMyEdit.Create(Self);
  MyEdit.Left := 10;
  MyEdit.Top  := 10;
  MyEdit.Parent := Form1;
  MyEdit.Cursor := crArrow;
  MyEdit.ExtCursorReadOnly := crNone;

  TestEdit := TMyEdit.Create(Self);
  TestEdit.Left := 10;
  TestEdit.Top  := 40;
  TestEdit.Parent := Form1;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  MyEdit.ReadOnly := not MyEdit.ReadOnly;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TestEdit.Cursor := MyEdit.Cursor;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  MyEdit.Cursor := crCross;
end;

{ TMyEdit }

function TMyEdit.GetMyCursor: TCursor;
begin
  Result := FCurrentCursor;
end;

procedure TMyEdit.SetMyCursor(AValue: TCursor);
begin
  FCurrentCursor := AValue;
  if ReadOnly then Exit;
  inherited SetCursor(AValue);
end;

procedure TMyEdit.SetReadOnly(Value: Boolean);
begin
  inherited SetReadOnly(Value);
  if Value then
    SetCursor(FExtCursorReadOnly)
  else
    Cursor := FCurrentCursor;
end;

procedure TMyEdit.SetExtCursorReadOnly(AValue: TCursor);
begin
  if FExtCursorReadOnly = AValue then Exit;
  FExtCursorReadOnly := AValue;
end;

end.

